From 9e922d6c654bf6f592a8298e593507ef687b1f49 Mon Sep 17 00:00:00 2001
From: Alison Wang <alison.wang@nxp.com>
Date: Tue, 5 Jul 2022 16:21:28 +0800
Subject: [PATCH 104/136] ethosu: Add remoteproc support in the NPU driver

Signed-off-by: Alison Wang <alison.wang@nxp.com>
Acked-by: Peng Fan <peng.fan@nxp.com>
Upstream-Status: Pending
---
 drivers/staging/ethosu/ethosu_device.c | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

diff --git a/drivers/staging/ethosu/ethosu_device.c b/drivers/staging/ethosu/ethosu_device.c
index b2d4737080ac..8ee1ccd711c6 100644
--- a/drivers/staging/ethosu/ethosu_device.c
+++ b/drivers/staging/ethosu/ethosu_device.c
@@ -38,6 +38,7 @@
 #include <linux/interrupt.h>
 #include <linux/io.h>
 #include <linux/of_reserved_mem.h>
+#include <linux/remoteproc.h>
 #include <linux/uaccess.h>
 #include <linux/slab.h>
 
@@ -49,6 +50,8 @@
 
 #define CAPABILITIES_RESP_TIMEOUT_MS 2000
 
+#define ETHOSU_FIRMWARE_NAME "ethosu_firmware"
+
 /****************************************************************************
  * Types
  ****************************************************************************/
@@ -243,11 +246,32 @@ static int ethosu_open(struct inode *inode,
 {
 	struct ethosu_device *edev =
 		container_of(inode->i_cdev, struct ethosu_device, cdev);
+	phandle rproc_phandle;
+	struct rproc *rproc;
+	int ret = 0;
 
 	file->private_data = edev;
 
 	dev_info(edev->dev, "Opening device node.\n");
 
+	if (of_property_read_u32(edev->dev->of_node, "fsl,cm33-proc",
+				 &rproc_phandle)) {
+		dev_err(edev->dev, "could not get rproc phandle\n");
+		return -ENODEV;
+	}
+
+	rproc = rproc_get_by_phandle(rproc_phandle);
+	if (!rproc) {
+		dev_err(edev->dev, "could not get rproc handle\n");
+		return -EINVAL;
+	}
+
+	rproc_set_firmware(rproc, ETHOSU_FIRMWARE_NAME);
+
+	ret = rproc_boot(rproc);
+	if (ret)
+		dev_err(edev->dev, "could not boot a remote processor\n");
+
 	return nonseekable_open(inode, file);
 }
 
-- 
2.25.1

